//+------------------------------------------------------------------+
//|                             One Side Gaussian Support Resistance |
//|                                                           mladen |
//|                                                                  |
//| original idea and first implementation by : Tinytjan             |
//| (http://codebase.mql4.com/ru/2735)                               |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfxgmail.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Red
#property indicator_color2 LimeGreen
#property indicator_color3 Silver
#property indicator_color4 Red
#property indicator_color5 LimeGreen
#property indicator_style3 STYLE_DOT
#property indicator_width4 1
#property indicator_width5 1

//
//
//
//
//

extern string TimeFrame  = "Current time frame";
extern int    SRPeriod   = 40;
extern int    SmoothType = 3;
extern int    PriceHigh  = PRICE_HIGH;
extern int    PriceLow   = PRICE_LOW;
extern bool   alertsOn                  = false;
extern bool   alertsOnCurrent           = true;
extern bool   alertsMessage             = true;
extern bool   alertsSound               = true;
extern bool   alertsEmail               = false;

//
//
//
//
//

double Resistance[];
double Support[];
double Average[];
double SmoothHigh[];
double SmoothLow[];
double ArrowUp[];
double ArrowDown[];
double trend[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   BuffersInit();
   IndicatorBuffers(8);
      SetIndexBuffer(0, Resistance); SetIndexLabel(0,"OS Gaussian resistance");
      SetIndexBuffer(1, Support);    SetIndexLabel(1,"OS Gaussian support");
      SetIndexBuffer(2, Average);    SetIndexLabel(2,"OS Gaussian average");
      SetIndexBuffer(3, ArrowUp);    SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);
      SetIndexBuffer(4, ArrowDown);  SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,159);
      SetIndexBuffer(5, SmoothHigh);
      SetIndexBuffer(6, SmoothLow);
      SetIndexBuffer(7, trend);
         SmoothType  = MathMax(MathMin(SmoothType,14),0);

         //
         //
         //
         //
         //
         
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0); 
         timeFrame         = stringToTimeFrame(TimeFrame);
   
         //
         //
         //
         //
         //
      
      IndicatorShortName(timeFrameToString(timeFrame)+" One side Gaussian SR("+SRPeriod+","+SmoothType+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Resistance[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
      
   if (timeFrame != Period())
   {
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (int i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            Resistance[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SRPeriod,SmoothType,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
            Support[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SRPeriod,SmoothType,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,1,y);
            trend[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SRPeriod,SmoothType,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,7,y);
            ArrowUp[i]    = EMPTY_VALUE;
            ArrowDown[i]  = EMPTY_VALUE;
            Average[i]    = (Support[i] + Resistance[i])/2;
               if (trend[i] ==  1 || trend[i] == 0)  ArrowUp[i]   = High[i];
               if (trend[i] == -1 || trend[i] == 0)  ArrowDown[i] = Low[i];
      }
      return(0);            
   }
   
   //
   //
   //
   //
   //
   
   for(i = limit; i >= 0; i--)
   {
      SmoothLow[i]  = Smooth(SmoothType,PRICE_LOW, i);
      SmoothHigh[i] = Smooth(SmoothType,PRICE_HIGH,i);
      Support[i]    = SmoothLow [ArrayMinimum(SmoothLow,SRPeriod,i)];
      Resistance[i] = SmoothHigh[ArrayMaximum(SmoothHigh,SRPeriod,i)];
      Average[i]    = (Support[i] + Resistance[i])/2;
      ArrowUp[i]    = EMPTY_VALUE;
      ArrowDown[i]  = EMPTY_VALUE;
      trend[i]      = -99;
         if (iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i) > Resistance[i])                                                      trend[i] =  1;
         if (iMA(NULL,0,1,0,MODE_SMA,PriceLow,i)  < Support[i])                                                         trend[i] = -1;
         if (iMA(NULL,0,1,0,MODE_SMA,PriceLow,i)  < Support[i] && iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i) > Resistance[i]) trend[i] =  0;
         if (trend[i] ==  1 || trend[i] == 0)  ArrowUp[i]   = High[i];
         if (trend[i] == -1 || trend[i] == 0)  ArrowDown[i] = Low[i];
   }
   manageAlerts();
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
         if (trend[whichBar] == 0) doAlert(whichBar,"up and down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(timeFrameToString(Period())+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," One side gaussian SR broken ",doWhat," level");
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"One side SR"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define MaxLength 987
int    levels[] = {1,2,3,5,8,13,21,34,55,89,144,233,377,610,987};
double GaussianBuffer[][15];

//
//
//
//
//
//

double Gaussian(int Size, int X)
{
   return (MathExp(-X*X*9/((Size + 1)*(Size + 1))));
}

//
//
//
//
//

void BuffersInit()
{
   int i;
   
   ArrayResize(GaussianBuffer,MaxLength);
   for (int k = 0; k < 15; k++)
   {
      double sum = 0.0;
         for (i = 0; i < MaxLength; i++) { if (i>=levels[k]) break; GaussianBuffer[i][k]  = Gaussian(levels[k],i); sum += GaussianBuffer[i][k];}
         for (i = 0; i < MaxLength; i++) { if (i>=levels[k]) break; GaussianBuffer[i][k] /= sum; }
   }                              
}

//
//
//
//
//

double Smooth(int level,int appliedPrice, int shift)
{
   double sum   = 0;
   int    limit = levels[level];
   
   if (shift >= (Bars - limit)) return(iMA(NULL,0,1,0,MODE_SMA,appliedPrice,shift));
   
   //
   //
   //
   //
   //
   
   for (int i = 0; i < limit; i++)
           sum += GaussianBuffer[i][level]*iMA(NULL,0,1,0,MODE_SMA,appliedPrice,shift+i);
   return (sum);
}

